---
title: configure.in
slug: Mozilla/Developer_guide/Build_Instructions/configure.in
tags:
  - Build documentation
  - Developing Mozilla
---
<p>The Mozilla {{ Source("configure") }} script is a standard method of determining compiler and system capabilities and options for Linux-based software. Mozilla uses <code>configure</code> on all platforms. <code>configure</code> is a shell script generated from an template file {{ Source("configure.in") }}, using <a class="external" href="http://www.gnu.org/software/autoconf/">Autoconf</a>.</p>
<p>Here's an example of how to add a configure option to the <a href="en/How_Mozilla's_build_system_works">build</a>. Please consult the build system owner (<a>Benjamin Smedberg</a>) before adding configure options. New options will only be accepted if they are going to be maintained and tested appropriately.</p>
<pre class="eval">MOZ_ARG_ENABLE_BOOL(foo,
[  --enable-foo     Insert some documentation here. Try to keep the spacing lined up right.],
    MOZ_FOO=1,
    MOZ_FOO=)

dnl AC_SUBST will replace @MOZ_FOO@ in makefiles.
AC_SUBST(MOZ_FOO)

dnl <b>If you need to use #ifdef MOZ_FOO in C/C++ code, use AC_DEFINE. In most cases this</b>
dnl <b>is unnecessary, as Makefile ifdefs are sufficient.</b>
if test -n "$MOZ_FOO"; then
  AC_DEFINE(MOZ_FOO)
fi
</pre>
<p>After editing <code>configure.in</code>, regenerate <code>configure</code> by running Autoconf 2.13. On most systems, the command is <code>autoconf-2.13</code>.</p>
<div class="note">
  Autoconf 2.5x will not work. See {{ Bug(104642) }} for details.</div>
<p>In {{ Source("config/autoconf.mk.in") }}, add the <code>MOZ_FOO</code> variable to the list of substituted variables:</p>
<pre class="eval">MOZ_FOO = @MOZ_FOO@
</pre>
<p>Since <code>autoconf.mk</code> is <a href="/en-US/docs/Standard_Makefile_Header">included at the top of every Mozilla Makefile</a>, the <code>MOZ_FOO</code> variable will be available to every makefile.</p>
